static int parse_dns_ans(unsigned char __far *packet, struct dns_query __far *query, unsigned packet_len);
static int find_socket_by_ports_and_remote_addr4(unsigned local_port, unsigned remote_port, struct ipv4_addr, unsigned udp);
static void tcp4_ack_socket(unsigned socket, struct tcp4_header *header);
static void tcp4_reack_socket(unsigned socket);
static void tcp4_recv_socket(unsigned socket, struct tcp4_header *header, unsigned char __far *packet, unsigned packet_len);
static void tcp4_remote_close(unsigned socket, struct tcp4_header *);
static void tcp4_verify_send(unsigned socket, struct tcp4_header *header);
static void delete_socket(unsigned socket, unsigned force);
static void udp4_recv_socket(unsigned socket, unsigned char __far *packet, unsigned packet_len);
//static int find_accepted_socket_ipv4(unsigned char *remote_addr, struct ipv4_addr remote_ip, unsigned port);
static int find_open_port_by_port(unsigned port, unsigned udp);
static int find_free_socket_index(void);
static void tcp4_synack_socket(unsigned n, struct tcp4_header *header);
static void tcp4_resynack_socket(unsigned);
static void tcp4_send_ack(unsigned socket);
static void tcp4_reset_socket(unsigned socket);
//static void add_socket_to_open_port(unsigned open_port, unsigned socket);
//static void del_socket_from_open_port(unsigned open_port, unsigned socket);
//static char socket_in_open_port(unsigned open_port, unsigned socket);
static int tcp4_packetizer(unsigned);
//static int find_socket_by_remote_addr4(struct ipv4_addr);
static void tcp4_remote_close_2(unsigned, struct tcp4_header*);
static int push_socket_queue(unsigned, unsigned);
static int pop_socket_queue(unsigned);
static int parse_dhcp_reply(unsigned char __far *, unsigned);
static int send_dhcp_request(void);

void __far timer_int(void);
extern void __far * __based(__segname("_CODE")) old_timer_handler;
extern void __far * __based(__segname("_CODE")) int21_handler;
extern void __far * __based(__segname("_CODE")) int13_handler;

void set_vector(unsigned vector, void __far *ptr);
#pragma aux set_vector parm [ax] [cx dx];

void go_tsr(unsigned char value, unsigned paragraphs);
#pragma aux go_tsr parm [ax] [dx];

void tcp_service();

struct ipv4_addr __based (__segname("_CODE")) ipv4_my_addr;
struct ipv4_addr __based (__segname("_CODE")) ipv4_broadcast;
struct ipv4_addr __based (__segname("_CODE")) ipv4_netmask;
struct ipv4_addr __based (__segname("_CODE")) ipv4_gateway;
struct ipv4_addr __based (__segname("_CODE")) ipv4_dns;
unsigned char __based (__segname("_CODE")) network_int;

#pragma aux pit_counter value [ax];
unsigned pit_counter(void);

struct mac_cache __based (__segname("_CODE")) arp_cache[ARP_CACHE_SIZE];

int __based (__segname("_CODE")) error_code = 0;

unsigned char __far * __based (__segname("_CODE")) input_buffer = 0;

struct driver __based (__segname("_CODE")) driver;

unsigned char __based (__segname("_CODE")) my_mac[6];
unsigned char __based (__segname("_CODE")) gateway_mac[6];

unsigned char __based (__segname("_CODE")) broadcast_mac[6] = { 0xFF, 0xFF, 0xFF,  0xFF, 0xFF, 0xFF };

struct raw_packet __based (__segname("_CODE")) raw_packet[RAW_PACKET_COUNT];

unsigned __based (__segname("_CODE")) raw_packet_index = 0;

unsigned __based (__segname("_CODE")) raw_packet_endindex = 0;
volatile unsigned __based (__segname("_CODE")) raw_packet_startindex = 0;

struct transmission_control_block __far * __far * __based (__segname("_CODE")) sockets;

struct open_port_control_block __far * __far * __based (__segname("_CODE")) open_ports;

struct dns_query __far * __based (__segname("_CODE")) dns_cache;

unsigned __based (__segname("_CODE")) dns_cache_index = 0;

int __based (__segname("_CODE")) socket_descriptor_index = 0;

volatile unsigned char __based (__segname("_CODE")) transmission_flag = 0;

//unsigned char pkt_buff[OUT_PACKET_SIZE];

unsigned char __far * __based(__segname("_CODE")) out_pkt_buffs[MAX_HIPERF_OUTPACKET_BUFFERS];

void save_psp(void);

unsigned __based(__segname("_CODE")) data_seg;
unsigned __based(__segname("_CODE")) stack_seg;
//unsigned __based(__segname("_CODE")) stack_ptr;
unsigned __based(__segname("_CODE")) old_stack_seg;
unsigned __based(__segname("_CODE")) old_stack_ptr;
unsigned __based(__segname("_CODE")) this_psp;
unsigned __based(__segname("_CODE")) user_psp;
unsigned __based(__segname("_CODE")) receiver_old_stack_seg;
unsigned __based(__segname("_CODE")) receiver_old_stack_ptr;

struct dhcp __based (__segname("_CODE")) lease;

void __far receiver_wrapper();

unsigned __based (__segname("_CODE")) rx_error_count = 0;
volatile unsigned __based (__segname("_CODE")) tx_error_count = 0;
volatile unsigned __based (__segname("_CODE")) rx_dropped_packets = 0;
unsigned __based (__segname("_CODE")) tx_dropped_packets = 0;
volatile unsigned __based (__segname("_CODE")) rx_packets = 0;
unsigned __based (__segname("_CODE")) tx_packets = 0;
volatile unsigned long __based (__segname("_CODE")) rx_bytes = 0;
unsigned long __based (__segname("_CODE")) tx_bytes = 0;

//void __far * __far receiver(unsigned phase, unsigned length);
//extern unsigned __far raw_buffer_free;

struct out_packet __far * __based(__segname("_CODE")) outgoing_packets;

int connect(char *, unsigned, char);
#pragma aux connect parm [dx] [bx] [cx] value [ax];

int socket_read(int, char __far *, unsigned);
#pragma aux socket_read parm [bx] [es dx] [cx] value [ax];

int socket_write(int, char __far*, unsigned);
#pragma aux socket_write parm [bx] [es dx] [cx] value [ax];

int close_socket(int);
#pragma aux close_socket parm [bx] value [ax];

int open_port(unsigned local_port, unsigned udp);
#pragma aux open_port parm [bx] [cx] value [ax];

unsigned service_packets(void);
#pragma aux service_packets value [ax];
