static void init_packet_header(unsigned char __far *packet, void __far *dst_mac)
{
  _fmemcpy((void __far*)packet, dst_mac, 6);

  _fmemcpy((void __far*)&packet[6], (void __far*)my_mac, 6);

  packet[12] = 0x08;
  packet[13] = 0x00;
}

static void init_ipv4_packet_header(struct ipv4_addr dst, unsigned char __far *packet, char __far *dest_mac)
{
  int n;

  if(!_fmemcmp((void __far*)&dst, (void __far*)&ipv4_broadcast, sizeof(struct ipv4_addr)))
    init_packet_header(packet, broadcast_mac);
  else
  {
  #ifdef ARP  
  if(!dest_mac)
  {
    if(address_in_same_ipv4_subnet(dst))
    {
      if(!_fmemcmp((void __far*)&dst, (void __far*)&ipv4_gateway, sizeof(struct ipv4_addr)))
        init_packet_header(packet, gateway_mac);
      else if((n = address_in_arp_cache4(dst)) >= 0)
        init_packet_header(packet, arp_cache[n].mac);
      else
      {
        send_arp_request_ipv4(dst);
        init_packet_header(packet, gateway_mac);
      }
    }
    else
  #endif 
      init_packet_header(packet, gateway_mac);
  #ifdef ARP
  }
  else
    init_packet_header(packet, dest_mac);
  #endif
  }
}

static unsigned get_free_port4(unsigned udp, struct ipv4_addr remote_addr, unsigned remote_port)
{
  unsigned retval;

  do
    retval = tsr_rand();  
  while(find_socket_by_ports_and_remote_addr4(retval, remote_port, remote_addr, udp) != -1);

  return retval;
}
