static unsigned char strtohex(char *str)
{
  unsigned char retval = 0;

  if(*str <= 0x39)
    retval = *str;
  else
    retval = 0x09 + *str;

  retval <<= 4;
  str++;

  if(*str <= 0x39)
    retval |= *str & 0x0F;
  else
    retval |= (0x09 + *str) & 0x0F;

  return retval;
}

static int load_ip_setup(void)
{
  static char * __based(__segname("_CODE")) settings[] =
  {
    "IPADDR", "BROADCAST", "NETMASK", "GATEWAY", "NAMESERVER", "MAC-GATEWAY",
    "DHCP", "MAC-MY"
  };
  char buff[80];
  unsigned p;
  unsigned n;
  struct ipv4_addr __based(__segname("_CODE")) *set;
  char *endptr;
  unsigned char dhcp_enabled = 0;
  unsigned char __based(__segname("_CODE")) * macptr;

  FILE *fp = fopen("setup.net", "rt");

  lease.user_dns = 0;

  if(!fp)
  {
    puts("Could not open setup file");
    return 1;
  }

  while(fgets(buff, 80, fp))
  {
    for(n=sizeof(settings)/sizeof(char*);n--;)
      if(!_fstrncmp(settings[n], buff, _fstrlen(settings[n])))
      {
        switch(n)
        {
          case 0:
            set = &ipv4_my_addr;
          break;
          case 1:
            set = &ipv4_broadcast;
          break;
          case 2:
            set = &ipv4_netmask;
          break;
          case 3:
            set = &ipv4_gateway;
          break;
          case 4:
            lease.user_dns = 1;
            set = &ipv4_dns;
          break;
          case 6:
            dhcp_enabled++;
          break;
        }
        if(n < 5)
        {
          set->p1 = strtouint((char *)strchr(buff, ' ') + 1, &endptr); // NOTE! Typecast from FAR to NEAR pointer, data segment must be automatically correct!
          set->p2 = strtouint(endptr+1, &endptr);
          set->p3 = strtouint(endptr+1, &endptr);
          set->p4 = strtouint(endptr+1, &endptr);
          printf("%s: %u.%u.%u.%u\n", settings[n], set->p1, set->p2, set->p3, set->p4);          
        }
        if(n == 5 || n == 7)
        {
          if(n == 5) macptr = gateway_mac;
          else macptr = my_mac;
          for(p=0,endptr=(char*)strchr(buff, ' ')+1;p<6;p++,endptr+=3)
            macptr[p] = strtohex(endptr);
          printf("%s: %.2X:%.2X:%.2X:%.2X:%.2X:%.2X\n", settings[n], macptr[0], macptr[1], macptr[2], macptr[3],
            macptr[4], macptr[5]);
        }
      }
  }
  fclose(fp);
  if(dhcp_enabled)
    lease.status = 3; // INIT
  else lease.status = -1; // DISABLED
  return 0;
}
