.8086

.MODEL small


PUBLIC copymem_
PUBLIC lenstr_
PUBLIC setmem_
PUBLIC chrmem_

_TEXT               SEGMENT BYTE PUBLIC USE16 'CODE'
                ASSUME CS:_TEXT                               

; dx:si = source, es:di = destination, cx = count
copymem_ proc near
;  pushf
;  push cx
  push ds
  mov ds, dx
  push di
;  push si
  cld

  test cl, 0x01
  jz copy_words ; if even count, copy only words
  ; else copy the last byte

  dec cx

  add di, cx
  add si, cx
  movsb
  inc cx
  sub di, cx
  sub si, cx
 
  copy_words:
  shr cx, 1
  rep movsw

;  pop si
  pop di
  pop ds
;  pop cx
;  popf
  ret  
copymem_ endp

; es:di = destination, al = set byte, cx = count
setmem_ proc near
;  pushf
;  push ax
;  push cx
  push di
  cld

  test cl, 0x01
  jz set_words

  dec cx
  add di, cx  
  stosb
  inc cx
  sub di, cx
  
  set_words:
  mov ah, al
  shr cx, 1
  rep stosw

  pop di
;  pop cx
;  pop ax
;  popf
  ret
setmem_ endp

; es:di = pointer to string
lenstr_ proc near
;  pushf
  cld
  push cx

; find null byte  
  mov cx, 0xFFFF
  sub cx, di
  xor al, al
  push di
  repne scasb

  mov ax, di
  dec ax
  pop di
; string length == ax - di
  sub ax, di

  pop cx
;  popf
  ret
lenstr_ endp

; al = byte, es:di = buffer, cx = count
chrmem_ proc near
  cld
  repne scasb
  jz chrmem_end
  xor di, di
  mov es, di
  ret
  chrmem_end:
  dec di
  ret
chrmem_ endp

_TEXT ENDS

END


