void __far *tsr_alloc_pragma(unsigned size);
#pragma aux tsr_alloc_pragma = \
  "add bx, 0xF" \
  "mov cl, 4" \
  "shr bx, cl" \
  "mov ah, 0x48" \
  "int 0x21" \
  "jnc success" \
  "xor ax, ax" \
  "xor cx, cx" \
  "jmp fail" \
  "success:" \
  "mov cx, ax" \
  "xor ax, ax" \
  "fail:" \
  value [cx ax] parm [bx];

static void __far *tsr_alloc(unsigned size)
{
  return tsr_alloc_pragma(size);
}

#define tcpmalloc(size) tsr_alloc(size);

void tsr_free_pragma(unsigned segment);
#pragma aux tsr_free_pragma = \
  "push ax" \
  "mov ah, 0x49" \
  "int 0x21" \
  "pop ax" \
  parm [es];

static void tsr_free(void __far *ptr)
{
  tsr_free_pragma(FP_SEG(ptr));
}

#define ffree(a) tsr_free(a)

static unsigned strtouint(char *str, char **endptr)
{
  unsigned retval = 0;
  unsigned mul;
  unsigned len = 0;
  unsigned add;

  while(*(str + len) >= '0' && *(str + len) <= '9')
    len++;

  while(len--)
  {
    mul = len;
    add = *str++ - '0';
    while(mul--) add *= 10;    
    retval += add;
  }
  *endptr = str;

  return retval;
}

unsigned int __based (__segname("_CODE")) DOSRAND_SEED;

static unsigned int tsr_rand(void)
{
  static unsigned __based(__segname("_CODE")) a;
  static unsigned __based(__segname("_CODE")) b;
  static unsigned __based(__segname("_CODE")) c;

  a++;
  b+=a+11;
  c-=b-19;

  return a+b+c + (DOSRAND_SEED = 23 * DOSRAND_SEED % 26479);
}

static void seed_dosrand(void)
{
  DOSRAND_SEED = ttime(0);
}

#define random() tsr_rand()

static void tsr(void);
